/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c5500\d1258_55.h> */
/****************************************************************/
/****************************************************************/
/* ADS1258 Interface Software Version 1.0 for the TMS320C5500   */
/* Copyright (C) 2005 Texas Instruments Incorporated            */
/* All Rights Reserved                                          */
/*--------------------------------------------------------------*/
/* $Revision: 11 $                        $JustDate: 12/02/05 $ */
/* $Author: A0746714 $                                          */
/****************************************************************/
#ifndef __TADS1258_FN_H
#define __TADS1258_FN_H


/* this define is needed for the API 2.x                        */
#define __CSL_AVAILABLE


/* include the data converter api interface file                */
#include "tidc_api.h"


/* include the interface files for the chip support library     */
#include <csl_dma.h>
#include <csl_mcbsp.h>


/****************************************************************/
/** Structure definition for configuration register 0 (CONFIG0) */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int rsv7               :1;
       unsigned int spirst             :1;
       unsigned int muxmod             :1;
       unsigned int bypas              :1;
       unsigned int clkenb             :1;
       unsigned int chop               :1;
       unsigned int stat               :1;
       unsigned int rsv0               :1;
   } control_bit;
} TADS1258CONFIG0;


/****************************************************************/
/** Structure definition for configuration register 1 (CONFIG1) */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int idlmod             :1;
       unsigned int dly                :3;
       unsigned int sbcs               :2;
       unsigned int drate              :2;
   } control_bit;
} TADS1258CONFIG1;


/****************************************************************/
/** Structure definition for multiplexer fixed-channel register
 *  (MUXSCH)                                                    */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int ainp               :4;
       unsigned int ainn               :4;
   } control_bit;
} TADS1258MUXSCH;


/****************************************************************/
/** Structure definition for multiplexer differential input
 *  select register (MUXDIF)                                    */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int diff7              :1;
       unsigned int diff6              :1;
       unsigned int diff5              :1;
       unsigned int diff4              :1;
       unsigned int diff3              :1;
       unsigned int diff2              :1;
       unsigned int diff1              :1;
       unsigned int diff0              :1;
   } control_bit;
} TADS1258MUXDIF;


/****************************************************************/
/** Structure definition for multiplexer single-ended input
 *  select register (MUXSG0)                                    */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int ain7               :1;
       unsigned int ain6               :1;
       unsigned int ain5               :1;
       unsigned int ain4               :1;
       unsigned int ain3               :1;
       unsigned int ain2               :1;
       unsigned int ain1               :1;
       unsigned int ain0               :1;
   } control_bit;
} TADS1258MUXSG0;


/****************************************************************/
/** Structure definition for multiplexer single-ended input
 *  select register (MUXSG1)                                    */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int ain15              :1;
       unsigned int ain14              :1;
       unsigned int ain13              :1;
       unsigned int ain12              :1;
       unsigned int ain11              :1;
       unsigned int ain10              :1;
       unsigned int ain9               :1;
       unsigned int ain8               :1;
   } control_bit;
} TADS1258MUXSG1;


/****************************************************************/
/** Structure definition for system reading select register
 *  (SYSRED)                                                    */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int rsv7               :1;
       unsigned int rsv6               :1;
       unsigned int ref                :1;
       unsigned int gain               :1;
       unsigned int temp               :1;
       unsigned int vcc                :1;
       unsigned int rsv1               :1;
       unsigned int offset             :1;
   } control_bit;
} TADS1258SYSRED;


/****************************************************************/
/** Structure definition for GPIO configuration register (GPIOC)*/
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int cio7               :1;
       unsigned int cio6               :1;
       unsigned int cio5               :1;
       unsigned int cio4               :1;
       unsigned int cio3               :1;
       unsigned int cio2               :1;
       unsigned int cio1               :1;
       unsigned int cio0               :1;
   } control_bit;
} TADS1258GPIOC;


/****************************************************************/
/** Structure definition for GPIO data register (GPIOD)         */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int dio7               :1;
       unsigned int dio6               :1;
       unsigned int dio5               :1;
       unsigned int dio4               :1;
       unsigned int dio3               :1;
       unsigned int dio2               :1;
       unsigned int dio1               :1;
       unsigned int dio0               :1;
   } control_bit;
} TADS1258GPIOD;


/****************************************************************/
/** Structure definition for device ID register (ID)            */
/****************************************************************/
typedef union
{
   unsigned int value;
   struct
   {
       unsigned int reserved           :8;
       unsigned int devid              :8;
  } control_bit;
} TADS1258ID;


/****************************************************************/
/** Data converter register structure definition.
 *  This structure can be used to access the initialization
 *  values for the ADS1258 from the data converter object.      */
/****************************************************************/
typedef struct
{
    TADS1258CONFIG0     config0;
    TADS1258CONFIG1     config1;
    TADS1258MUXSCH      muxsch;
    TADS1258MUXDIF      muxdif;
    TADS1258MUXSG0      muxsg0;
    TADS1258MUXSG1      muxsg1;
    TADS1258SYSRED      sysred;
    TADS1258GPIOC       gpioc;
    TADS1258GPIOD       gpiod;
    TADS1258ID          devid;
} TADS1258REGS;




/****************************************************************/
/** Buffer object definition for dual buffering                 */
/****************************************************************/
typedef struct
{
    void             (*ptrCallBack)(void *);/**< ptr to callback*/
    unsigned long    *ulBufPtr;      /**< read buffer pointer   */
    unsigned int     uiBufSize;      /**< read buffer size      */
    volatile unsigned int uiStatus;  /**<  status of the buffer */
} TADS1258BUFOBJ;


/****************************************************************/
/** \struct TADS1258
 *  Definition of the data converter object. This is the main
 *  object to work with.                                        */
/****************************************************************/
typedef struct
{
/** \var f
 *   Structure for the API function pointers.
 *   They are declared in tidc_api.h and defined in tidc_api.c. */
/** \var  DCP_ SERIAL *serial
 *   Pointer to the McBSP configuration
 *   structure as defined in the tidc_api.h.                    */
/** \var regs
 *  Structure for the registers of the ADS1258. This structure
 *  will be initialized by the code and the values there will
 *  be sent to the device during dc_configure(). Any change
 *  the register values need to be submitted to the device
 *  using the dc_control() function.                            */
/** \var initRegs
 *  This structure is the backup structure for TADS1258REGS regs.
 *  At startup, it is initialized to the same values as regs, but
 *  will not be changed during the program. The function
 *  dc_close() will use these values to re-initialize the
 *  converter with the original register settings.              */
/** \var xferBuffer[2]
 *  These array holds two structures of the tye TADS1258BUFOBJ,
 *  which are used to hold information about the buffers
 *  submitted.                                                  */
/** \var hDmaRcv
 *  Handle to the DMA channel for the data transfer from the
 *  serial port to the memory array. This handle will be created
 *  by the function DMA_open(), which is called during
 *  dc_configure().                                             */
/** \var hDmaXmt
 *  Handle to the DMA channel for the data transfer from the
 *  dummy memory location to the McBSP. This transfer is necessary
 *  to trigger the activity on the SCLK line. The handle will be
 *  created by the function DMA_open(), which is called during
 *  dc_configure().                                             */
/** \var iDmaChanNumber
 *  Number of the DMA channel to be used to collect the data
 *  from the data converter. This channel will be used to create
 *  the hDmRcv handle.                                          */
/** \var uiDrdyIntNum
 *  This variable holds the number of the interrupt line of the
 *  DSP, where the DRDY line is connected to.                   */


/** \var uiMcbspPeriod
 *  Value for the McBSP Period Register. Will be used to set the
 *  speed of the serial port during dc_configure().             */
/** \var iXferInProgress
 *  This value indicates if there is a data transfer ongoing and
 *  can have the following values:
 *      - 0: No transfer is ongoing
 *      - 1: One transfer is ongoing
 *      - 2: One transfer is ongoing and another is submitted.  */
/** \var uiRcvCcrValue
 *  Backup for the receive DMA Channel Control Register.        */
/** \var uiXmtCcrValue
 *  Backup for the receive DMA Channel Control Register.        */
/** \var iObjectIndex
 *  Holds the index of the last buffer object used.             */
/****************************************************************/
    TTIDC3             f;
    DCP_SERIAL         *serial;
    TADS1258REGS       regs;
    TADS1258REGS       initRegs;
    TADS1258BUFOBJ     xferBuffer[2];
    DMA_Handle         hDmaRcv;
    DMA_Handle         hDmaXmt;
    int                iDmaChanNumber;
    unsigned int       uiDrdyIntNum;
    unsigned int       uiMcbspPeriod;
    volatile int       iXferInProgress;
    unsigned int       uiRcvCcrValue;
    unsigned int       uiXmtCcrValue;
    int                iObjectIndex;
} TADS1258;


/****************************************************************/
/* Define external DC object pointer(s)                         */
/****************************************************************/
extern TADS1258 Ads1258_1;
extern DCP_SERIAL serial1;



/****************************************************************/
/* Deklarations for the exported functions                      */
/****************************************************************/
TTIDCSTATUS ADS1258_configure(void *pDC);
TTIDCSTATUS ADS1258_control(void *pDC, int iCmd, void *iValue);
TTIDCSTATUS ADS1258_readsample(void *pDC, long *lData);
TTIDCSTATUS ADS1258_writesample(void *pDC, long lData);
TTIDCSTATUS ADS1258_readblock(void *pDC, void *pData,
                             unsigned long ulCount,
                             void (*callback) (void *));
TTIDCSTATUS ADS1258_writeblock(void *pDC, void *pData,
                              unsigned long ulCount,
                              void (*callback) (void *));
TTIDCSTATUS ADS1258_close(void *pDC);
interrupt void ADS1258_rblockFinished(void);
unsigned long ADS1258_getFinishedBufferAddress(TADS1258 *pADS);
unsigned int ADS1258_getFinishedBufferSize(TADS1258 *pADS);




/****************************************************************/
/* Define commands for the dc_control() function                */
/****************************************************************/
#define ADS1258_CMD_DATAREAD      (0x0000)
#define ADS1258_CMD_DATAREG       (0x2000)
#define ADS1258_CMD_REGISTERREAD  (0x4000)
#define ADS1258_CMD_REGISTERWRITE (0x6000)
#define ADS1258_CMD_PULSESTOP     (0x0080)
#define ADS1258_CMD_CONTINUOUS    (0x00A0)
#define ADS1258_CMD_RESET         (0x00C0)
#define ADS1258_MUL               (0x1000)


/****************************************************************/
/* Define names for the register addresses                      */
/****************************************************************/
#define ADS1258_CONFIG0           (0x0000)
#define ADS1258_CONFIG1           (0x0100)
#define ADS1258_MUXSCH            (0x0200)
#define ADS1258_MUXDIF            (0x0300)
#define ADS1258_MUXSG0            (0x0400)
#define ADS1258_MUXSG1            (0x0500)
#define ADS1258_SYSRED            (0x0600)
#define ADS1258_GPIOC             (0x0700)
#define ADS1258_GPIOD             (0x0800)
#define ADS1258_ID                (0x0900)


/****************************************************************/
/* ADS1258 defines for control registers bit set/clear          */
/****************************************************************/
/* register CONFIG0                                             */
#define ADS1258_SPIRST            (0x0040)
#define ADS1258_MUXMOD            (0x0020)
#define ADS1258_BYPAS             (0x0010)
#define ADS1258_CLKENB            (0x0008)
#define ADS1258_CHOP              (0x0004)
#define ADS1258_STAT              (0x0002)


/* register CONFIG1                                             */
#define ADS1258_IDLMOD            (0x0080)
#define ADS1258_DLY_0             (0x0000)
#define ADS1258_DLY_1             (0x0010)
#define ADS1258_DLY_2             (0x0020)
#define ADS1258_DLY_3             (0x0030)
#define ADS1258_DLY_4             (0x0040)
#define ADS1258_DLY_5             (0x0050)
#define ADS1258_DLY_6             (0x0060)
#define ADS1258_DLY_7             (0x0070)
#define ADS1258_SBCS_0            (0x0000)
#define ADS1258_SBCS_1            (0x0004)
#define ADS1258_SBCS_2            (0x0008)
#define ADS1258_SBCS_3            (0x000C)
#define ADS1258_DRATE_0           (0x0000)
#define ADS1258_DRATE_1           (0x0001)
#define ADS1258_DRATE_2           (0x0002)
#define ADS1258_DRATE_3           (0x0003)


/* register MUXSCH                                              */
#define ADS1258_AINP_0            (0x0000)
#define ADS1258_AINP_1            (0x0010)
#define ADS1258_AINP_2            (0x0020)
#define ADS1258_AINP_3            (0x0030)
#define ADS1258_AINP_4            (0x0040)
#define ADS1258_AINP_5            (0x0050)
#define ADS1258_AINP_6            (0x0060)
#define ADS1258_AINP_7            (0x0070)
#define ADS1258_AINP_8            (0x0080)
#define ADS1258_AINP_9            (0x0090)
#define ADS1258_AINP_10           (0x00A0)
#define ADS1258_AINP_11           (0x00B0)
#define ADS1258_AINP_12           (0x00C0)
#define ADS1258_AINP_13           (0x00D0)
#define ADS1258_AINP_14           (0x00E0)
#define ADS1258_AINP_15           (0x00F0)


#define ADS1258_AINN_0            (0x0000)
#define ADS1258_AINN_1            (0x0001)
#define ADS1258_AINN_2            (0x0002)
#define ADS1258_AINN_3            (0x0003)
#define ADS1258_AINN_4            (0x0004)
#define ADS1258_AINN_5            (0x0005)
#define ADS1258_AINN_6            (0x0006)
#define ADS1258_AINN_7            (0x0007)
#define ADS1258_AINN_8            (0x0008)
#define ADS1258_AINN_9            (0x0009)
#define ADS1258_AINN_10           (0x000A)
#define ADS1258_AINN_11           (0x000B)
#define ADS1258_AINN_12           (0x000C)
#define ADS1258_AINN_13           (0x000D)
#define ADS1258_AINN_14           (0x000E)
#define ADS1258_AINN_15           (0x000F)


/* register MUXDIF                                              */
#define ADS1258_DIFF_0_1          (0x0001)
#define ADS1258_DIFF_2_3          (0x0002)
#define ADS1258_DIFF_4_5          (0x0004)
#define ADS1258_DIFF_6_7          (0x0008)
#define ADS1258_DIFF_8_9          (0x0010)
#define ADS1258_DIFF_10_11        (0x0020)
#define ADS1258_DIFF_12_13        (0x0040)
#define ADS1258_DIFF_14_15        (0x0080)


/* register MUXSG0                                              */
#define ADS1258_AIN0              (0x0001)
#define ADS1258_AIN1              (0x0002)
#define ADS1258_AIN2              (0x0004)
#define ADS1258_AIN3              (0x0008)
#define ADS1258_AIN4              (0x0010)
#define ADS1258_AIN5              (0x0020)
#define ADS1258_AIN6              (0x0040)
#define ADS1258_AIN7              (0x0080)


/* register MUXSG1                                              */
#define ADS1258_AIN8              (0x0001)
#define ADS1258_AIN9              (0x0002)
#define ADS1258_AIN10             (0x0004)
#define ADS1258_AIN11             (0x0008)
#define ADS1258_AIN12             (0x0010)
#define ADS1258_AIN13             (0x0020)
#define ADS1258_AIN14             (0x0040)
#define ADS1258_AIN15             (0x0080)


/* register SYSRED                                              */
#define ADS1258_GAIN              (0x0020)
#define ADS1258_REF               (0x0010)
#define ADS1258_TEMP              (0x0008)
#define ADS1258_VCC               (0x0004)
#define ADS1258_OFFSET            (0x0001)


/* register GPIOC                                               */
#define ADS1258_GPIO0_IN          (0x0001)
#define ADS1258_GPIO1_IN          (0x0002)
#define ADS1258_GPIO2_IN          (0x0004)
#define ADS1258_GPIO3_IN          (0x0008)
#define ADS1258_GPIO4_IN          (0x0010)
#define ADS1258_GPIO5_IN          (0x0020)
#define ADS1258_GPIO6_IN          (0x0040)
#define ADS1258_GPIO7_IN          (0x0080)


#define ADS1258_GPIO0_OUT         (0x0000)
#define ADS1258_GPIO1_OUT         (0x0000)
#define ADS1258_GPIO2_OUT         (0x0000)
#define ADS1258_GPIO3_OUT         (0x0000)
#define ADS1258_GPIO4_OUT         (0x0000)
#define ADS1258_GPIO5_OUT         (0x0000)
#define ADS1258_GPIO6_OUT         (0x0000)
#define ADS1258_GPIO7_OUT         (0x0000)


/* register GPIOC                                               */
#define ADS1258_GPIO0_HIGH        (0x0001)
#define ADS1258_GPIO1_HIGH        (0x0002)
#define ADS1258_GPIO2_HIGH        (0x0004)
#define ADS1258_GPIO3_HIGH        (0x0008)
#define ADS1258_GPIO4_HIGH        (0x0010)
#define ADS1258_GPIO5_HIGH        (0x0020)
#define ADS1258_GPIO6_HIGH        (0x0040)
#define ADS1258_GPIO7_HIGH        (0x0080)


#define ADS1258_GPIO0_LOW         (0x0000)
#define ADS1258_GPIO1_LOW         (0x0000)
#define ADS1258_GPIO2_LOW         (0x0000)
#define ADS1258_GPIO3_LOW         (0x0000)
#define ADS1258_GPIO4_LOW         (0x0000)
#define ADS1258_GPIO5_LOW         (0x0000)
#define ADS1258_GPIO6_LOW         (0x0000)
#define ADS1258_GPIO7_LOW         (0x0000)


/* register ID                                               */
#define ADS1258_MAGIC             (0x008B)


/* other useful definitions                                     */
#define ADS1258_STARTPIN_LOW      (0x0000)
#define ADS1258_STARTPIN_HIGH     (0x0001)
#define ADS1258_MAX_BUFFERS       (0x0002)


/****************************************************************/
/* Definitions for the basic data mover                         */
/****************************************************************/
#define ADS1258_DMA_INPUT   (0)      /* read from converter     */
#define ADS1258_DMA_OUTPUT  (1)
#define ADS1258_DMA_ENDPROG (0x0800u)/* mask for the ENDPROG bit*/
#define ADS1258_DMA_SYNC    (0x001Fu)/* mask for the SYNC bits  */


/****************************************************************/
/* Definitions for the DMA channel registers                    */
/****************************************************************/
/****************************************************************/
/* Define for the channel control register DMACCR               */
/* operating mode: Input                                        */
/* Value: 0x48C0 = 0100 1000 1100 0000                          */
/*                 |||| |||| |||| ||||                          */
/*                 |||| |||| |||+ ++++- SYNC (set by function)  */
/*                 |||| |||| ||+------- FS   (element)          */
/*                 |||| |||| |+-------- PRIO (high)             */
/*                 |||| |||| +--------- EN   (enable)           */
/*                 |||| |||+----------- AUTOINIT (off)          */
/*                 |||| ||+------------ REPEAT (off)            */
/*                 |||| |+------------- RESERVED                */
/*                 |||| +-------------- ENDPROG (on)            */
/*                 ||++---------------- SRCAMODE (constant)     */
/*                 ++------------------ DSTAMODE (autoincr.)    */
/****************************************************************/
#define ADS1258_DMACCR_INPUT_VALUE (0x48C0u)




/****************************************************************/
/* define for the channel control register DMACCR              */
/* operating mode: Output                                      */
/* Value: 0x08C0 = 0000 1000 1100 0000                          */
/*                 |||| |||| |||| ||||                         */
/*                 |||| |||| |||+ ++++- SYNC (set by function) */
/*                 |||| |||| ||+------- FS   (element)          */
/*                 |||| |||| |+-------- PRIO (high)            */
/*                 |||| |||| +--------- EN   (enable)           */
/*                 |||| |||+----------- AUTOINIT (off)         */
/*                 |||| ||+------------ REPEAT (off)           */
/*                 |||| |+------------- RESERVED               */
/*                 |||| +-------------- ENDPROG (on)           */
/*                 ||++---------------- SRCAMODE (constant)    */
/*                 ++------------------ DSTAMODE (constant)    */
/****************************************************************/
#define ADS1258_DMACCR_OUTPUT_VALUE   (0x08C0u)








/****************************************************************/
/* define for the channel interrupt control register DMACICR    */
/* operating mode: input                                        */
/* Value: 0x0020 = 0000 0000 0010 0000                          */
/*                 |||| |||| |||| ||||                          */
/*                 |||| |||| |||| |||+- TIMEOUTIE (off)         */
/*                 |||| |||| |||| ||+-- DROPIE (off)            */
/*                 |||| |||| |||| |+--- HALFIE (off)            */
/*                 |||| |||| |||| +---- FRAMIE (off)            */
/*                 |||| |||| |||+------ LASTIE (off)            */
/*                 |||| |||| ||+------- BLOCKIE (on)            */
/*                 ++++ ++++ ++-------- RESERVED                */
/****************************************************************/
#define ADS1258_DMACICR_INPUT_VALUE   (0x0020u)


/****************************************************************/
/* define for the channel interrupt control register DMACICR    */
/* operating mode: output                                       */
/* Value: 0x0000 = 0000 0000 0000 0000                          */
/*                 |||| |||| |||| ||||                          */
/*                 |||| |||| |||| |||+- TIMEOUTIE (off)         */
/*                 |||| |||| |||| ||+-- DROPIE (off)            */
/*                 |||| |||| |||| |+--- HALFIE (off)            */
/*                 |||| |||| |||| +---- FRAMIE (off)            */
/*                 |||| |||| |||+------ LASTIE (off)            */
/*                 |||| |||| ||+------- BLOCKIE (off)           */
/*                 ++++ ++++ ++-------- RESERVED                */
/****************************************************************/
#define ADS1258_DMACICR_OUTPUT_VALUE   (0x0000u)


/****************************************************************/
/* define for the channel source destination parameter register */
/* DMACSDP                                                      */
/* operating mode: Input                                        */
/* Value: 0x000E = 0000 0000 0000 1110                          */
/*                 |||| |||| |||| ||||                          */
/*                 |||| |||| |||| ||++- DATATYPE (32 bit)       */
/*                 |||| |||| ||++-++--- SRC (peripheral)        */
/*                 |||| |||| |+-------- SRCPACK (off)           */
/*                 |||| |||+-+--------- SRCBEN (off)            */
/*                 |||+ +++------------ DST (set by function)   */
/*                 ||+- --------------- DSTPACK (off)           */
/*                 ++-- --------------- SRCBEN (off)            */
/****************************************************************/
#define ADS1258_DMACSDP_INPUT_VALUE  (0x000Eu)


/****************************************************************/
/* define for the channel source destination parameter register */
/* DMACSDP                                                      */
/* operating mode: Output                                       */
/* Value: 0x0602 = 0000 0110 0000 0010                          */
/*                 |||| |||| |||| ||||                          */
/*                 |||| |||| |||| ||++- DATATYPE (32 bit)       */
/*                 |||| |||| ||++-++--- SRC (set by function)   */
/*                 |||| |||| |+-------- SRCPACK (off)           */
/*                 |||| |||+-+--------- SRCBEN (off)            */
/*                 |||+ +++------------ DST (peripheral)        */
/*                 ||+- --------------- DSTPACK (off)           */
/*                 ++-- --------------- SRCBEN (off)            */
/****************************************************************/
#define ADS1258_DMACSDP_OUTPUT_VALUE  (0x0602u)


/***************************************************************/
/* define values for the different memory areas, as they are   */
/* needed for the DMACSDP register at runtime                  */
/***************************************************************/
/* SRC/ DST  = 00 SARAM                                        */
/*           = 01 DARAM                                        */
/*           = 10 EMIF                                         */
/*           = 11 RESERVED                                     */
/***************************************************************/
#define ADS1258_DMACSDP_SARAM_SRC  (0x0000u)
#define ADS1258_DMACSDP_DARAM_SRC  (0x0004u)
#define ADS1258_DMACSDP_EMIF_SRC   (0x0008u)
#define ADS1258_DMACSDP_PERIPH_SRC (0x000Cu)


#define ADS1258_DMACSDP_SARAM_DST  (0x0000u)
#define ADS1258_DMACSDP_DARAM_DST  (0x0200u)
#define ADS1258_DMACSDP_EMIF_DST   (0x0400u)
#define ADS1258_DMACSDP_PERIPH_DST (0x0600u)


#endif /* __TADS1258_FN_H */

/****************************************************************/
/* END OF t1258_fn.h                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
